#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <cscomm.h>

#include "sizes.h"
#include "types.h"
#include "comlat.h"
/* #include "latprint.h" */
#include "bound.h"

#define  TRUE  (1==1)
#define  FALSE (0==1)

void neighbour_iter()
{
   AuxType:lattice uplabel, passlabel; 
   int axis;

   /* Patch to get pointers started. */
   /*--------------------------------*/

   for(axis=0;axis<DIMENSIONS;axis++){
       passlabel = Label_cluster ;
       where( boundary_fnd[axis] )  passlabel = MAXINT ;   /* No point in ORing */

       /* uplabel  =  [.+1%%SIZE][.] passlabel ; */

       everywhere{
           uplabel = from_torus_dim( &passlabel, axis, +1);  /* +1 dist */
       }			                 /*    ^ for "get", -1 for "send" */
       /* where(pcoord(axis)==SIZE-1) */
       Label_cluster <?= uplabel ;

       /*     Must be done in both directions!!!!  1/8/91        */
       /***----------------------------------------------------***/
        everywhere{
	    uplabel = from_torus_dim( &Label_cluster, axis, -1);  /* -1 dist */
						       /*    ^ for "get", +1 for "send" */
	}
#       ifndef NO_IMPROVE
	where( Label_cluster == uplabel )
	        boundary_fnd[axis] = FALSE;
#       endif  NO_IMPROVE
	where( (!boundary_fnd[axis]) )
		Label_cluster <?= uplabel ;
   }

}
